#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <err.h>
#include <string.h>
 
#define RESPONSE_DATA "HTTP/1.1 200 OK\r\n" \
"Date: Thu, 09 Nov 2010 14:49:00 GMT\r\n" \
"Server: Apache/2.4.1 (Unix)\r\n" \
"Content-Type: text/html\r\n" \
"Content-Length: 0\r\n" \
"\r\n"

#define FILE_DATA "This is a test"
#define BUFFER_SIZE 2048

#ifdef DEBUG
#define PRINT_MSG(fmt, ...) printf(fmt, ##__VA_ARGS__)
#else
#define PRINT_MSG(fmt, ...)
#endif

int main()
{
	int enable;
	int client_socket, server_socket;
	struct sockaddr_in server_addr, client_addr;
	socklen_t len;
	ssize_t bytes_recv, buffer_pos;
	char buffer[BUFFER_SIZE];
	int call_shutdown = 0;

	server_socket = socket(AF_INET, SOCK_STREAM, 0);

	enable = 1;
	setsockopt(server_socket, SOL_SOCKET, SO_REUSEADDR, &enable, sizeof(int));

	server_addr.sin_family = AF_INET;
	server_addr.sin_addr.s_addr = INADDR_ANY;
	server_addr.sin_port = htons(8080);

	bind(server_socket, (struct sockaddr *) &server_addr, sizeof(server_addr));

	PRINT_MSG("Server listening\n");
	listen(server_socket, 1);

	len = sizeof(client_addr);
	client_socket = accept(server_socket, (struct sockaddr *) &client_addr, &len);
	PRINT_MSG("Client connected\n");
	while (1)
	{
		usleep((rand() % 100));
		if (!call_shutdown)
		{
			shutdown(client_socket, SHUT_WR);
			close(client_socket);
			PRINT_MSG("Waiting for accept\n");
			client_socket = accept(server_socket, (struct sockaddr *) &client_addr, &len);
			call_shutdown = 2;
		}
		else
		{
			call_shutdown--;
			if (client_socket != -1)
			{
				PRINT_MSG("Client connected\n");
				buffer_pos = 0;
				while (1)
				{
					bytes_recv = recv(client_socket, &buffer[buffer_pos], sizeof(buffer) - buffer_pos, 0);
					if (bytes_recv > 0)
					{
						PRINT_MSG("Received %ld bytes from client\n", bytes_recv);
						buffer_pos += bytes_recv;
						if ((buffer_pos > 4) && (strncmp(&buffer[buffer_pos - 4], "--\r\n", 4) == 0))
						{
							PRINT_MSG("Received full POST\n");
							break;
						}
					}
					else
					{
						PRINT_MSG("Client closed\n");
						break;
					}
				}
				if (bytes_recv > 0)
				{
					int search_length = buffer_pos - strlen(FILE_DATA) + 1;
					int current_pos = 0;
					int match_found = 0;
					for ( ; search_length-- > 0; current_pos++)
					{
						if (!memcmp(&buffer[current_pos], FILE_DATA, strlen(FILE_DATA)))
						{
							match_found = 1;
						}
					}
					if (match_found)
					{
						send(client_socket, RESPONSE_DATA, sizeof(RESPONSE_DATA) - 1, 0);
						PRINT_MSG("Response sent\n");
					}
					else
					{
						printf("Missing data from body!\n");
						return 1;
					}
				}
			}
		}
	}
}
